<html>

<head>
    <title>ELECTION TICKER</title>
    <meta charset="UTF-8">
</head>

<body id="body">
    <div style="width: 100%;" id="flex">
        <div style="width: 80%;">
            <button id="btn" onclick="activateSound()">ACTIVATE SOUND ALARM</button>
            <br>
            <h2>CURRENT STANDING</h2>
            <h2>BIDEN: 253 --- TRUMP: 214</h2>
            <br>
            <table>
                <tbody id="feld">
    
                </tbody>
            </table>
            <h2 id="projection"></h2>
            <h3 id="projection2"></h3>
            <h4 id="projection3"></h4>
            <h2>SENATE RACE</h2>
            <h2>DEM: 47 -- 6 -- REP: 47</h2>
            <br>
            <table>
                <tbody id="feldSenate">
    
                </tbody>
            </table>
            <h2>SENATE PROJECTION</h2>
            <h2 id="projectionSenate"></h2>
        </div>
    </div>
</body>
<audio id="alert" src="./alert"></audio>
<script>
    function activateSound() {
        alerts = true;
        document.getElementById("btn").remove();
    }
    var alerts = false;
    function playalert(d) {
        if (alerts && d != null && d.length > 0) document.getElementById("alert").play();
    }
    var serverip = `${window.location.href}`;
    request();
    var last = '';
    function request() {

        var req = new XMLHttpRequest();
        req.open("GET", serverip + "data", true);
        req.setRequestHeader("Content-type", "application/json");
        req.setRequestHeader('Accept', 'application/json');
        req.onreadystatechange = function () {
            if (this.readyState == 4 && this.status == 200) {
                var d = JSON.parse(req.responseText);
                if (last != req.responseText && last != '') playalert(d);
                last = req.responseText;
                document.getElementById("feld").innerHTML = '';
                document.getElementById('feld').innerHTML += '<tr style="background: rgba(200, 240, 163, 0.562)" id="header"></tr>';
                document.getElementById('feld').children[0].innerHTML = `<td class="colseg">STATE</td><td class="colseg">TRUMP</td><td class="colseg">BIDEN</td><td class="colseg">COUNTED</td><td class="colseg">LEFTOVER VOTES</td><td class="colseg">BIDEN NEEDS</td><td class="colseg">VOTES IN EC</td>`;
                var ecvb = 0;
                var ecvt = 0;
                var oecvb = 0;
                var oecvt = 0;
                var otctc = 0;
                var voecvb = 0;
                var voecvt = 0;
                var votctc = 0;
                var tctc = 0;
                for (var i = 0; i < d.length; i++) {
                    var color = '';
                    if (d[i][5] < 50 || d[i][1] < d[i][2]) {
                        color = "rgba(0, 119, 255, 0.562)";
                        ecvb += d[i][6];
                        oecvb += d[i][6];
                        voecvb += d[i][6];
                    } else if (d[i][5] > 51 && d[i][1] > d[i][2]) {
                        color = "rgba(255, 0, 0, 0.562)"; 
                        ecvt += d[i][6];
                        if (d[i][5] < 55) {
                            oecvb += d[i][6];
                            voecvb += d[i][6];
                        } else {
                            if (d[i][5] < 60)
                                voecvb += d[i][6];
                            else
                                voecvt += d[i][6];
                            oecvt += d[i][6];
                        }
                    } else {
                        color = "rgba(191, 205, 221, 0.562)";
                        tctc += d[i][6];
                        otctc += d[i][6];
                        votctc += d[i][6];
                    }
                    document.getElementById('feld').innerHTML += '<tr style="background: ' + color + ';" id="' + d[i][0] + '"></tr>';
                    document.getElementById('feld').children[i + 1].innerHTML = `<td class="colseg">${d[i][0]}</td><td class="colseg">${d[i][1]}</td><td class="colseg">${d[i][2]}</td><td class="colseg">${d[i][3]}%</td><td class="colseg">${d[i][4]}</td><td class="colseg">${d[i][5]}%</td><td class="colseg">${d[i][6]}</td>`;
                }
                document.getElementById('projection').innerHTML = "CONSERVATIVE PROJECTION:<br> BIDEN: " + (ecvb + 253) + " --- " + tctc + " --- TRUMP: " + (ecvt + 214);
                document.getElementById('projection2').innerHTML = "OPTIMISTIC PROJECTION:<br> BIDEN: " + (oecvb + 253) + " --- " + otctc + " --- TRUMP: " + (oecvt + 214);
                document.getElementById('projection3').innerHTML = "VERY OPTIMISTIC PROJECTION:<br> BIDEN: " + (voecvb + 253) + " --- " + votctc + " --- TRUMP: " + (voecvt + 214);
            }

        }
        req.send();
    }
    setInterval(request, 1000 * 10);

    function requestSenate() {

        var reqSenate = new XMLHttpRequest();
        reqSenate.open("GET", serverip + "dataSenate", true);
        reqSenate.setRequestHeader("Content-type", "application/json");
        reqSenate.setRequestHeader('Accept', 'application/json');
        reqSenate.onreadystatechange = function () {
            if (this.readyState == 4 && this.status == 200) {
                var d = JSON.parse(reqSenate.responseText);
                document.getElementById('feldSenate').innerHTML = '';
                document.getElementById('feldSenate').innerHTML += '<tr style="background: rgba(200, 240, 163, 0.562)" id="headerSenate"></tr>';
                document.getElementById('headerSenate').innerHTML = `<td class="colseg">STATE</td><td class="colseg">REP</td><td class="colseg">DEM</td><td class="colseg">COUNTED</td><td class="colseg">LEFTOVER VOTES</td><td class="colseg">DEMS NEED</td><td class="colseg">SEATS</td>`;
                var rep = 0;
                var dem = 0;
                var tctc = 1; //senate special election in georgia
                for (var i = 0; i < d.length; i++) {
                    var color = '';
                    if (d[i][5] < 50) {
                        color = "rgba(0, 119, 255, 0.562)";
                        dem += d[i][6];
                    } else if (d[i][5] > 51) {
                        color = "rgba(255, 0, 0, 0.562)"; 
                        rep += d[i][6];
                    } else {
                        color = "rgba(191, 205, 221, 0.562)";
                        tctc += d[i][6];
                    }
                    document.getElementById('feldSenate').innerHTML += '<tr style="background: ' + color + ';" id="' + d[i][0] + 'Senate"></tr>';
                    document.getElementById(d[i][0] + 'Senate').innerHTML = `<td class="colseg">${d[i][0]}</td><td class="colseg">${d[i][1]}</td><td class="colseg">${d[i][2]}</td><td class="colseg">${d[i][3]}%</td><td class="colseg">${d[i][4]}</td><td class="colseg">${d[i][5]}%</td><td class="colseg">${d[i][6]}</td>`;
                }
                document.getElementById('projectionSenate').innerHTML = "DEM: " + (dem + 47) + " --- " + tctc + " --- REP: " + (rep + 47);
            }

        }
        reqSenate.send();
    }
    requestSenate();
    setInterval(requestSenate, 1000 * 10);
</script>
<style>
    html {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 30px;
    }

    table,
    td {
        border: 1px solid black;
        text-align: center;
        padding: 4px;
    }

    #flex {
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-content: center;
    }
</style>

</html>